package com.maroontress.gcovparser;

import java.io.IOException;
import java.nio.ByteBuffer;
import java.nio.charset.Charset;

/**
   gcno/gcdaեѡ뤿Υ桼ƥƥ饹Ǥ
*/
public final class Parser {

    /** INT32ΥХȥǤ */
    public static final int SIZE_INT32 = 4;

    /** ʸåȤǤ */
    private static final Charset CHARSET = Charset.defaultCharset();

    /**
       󥹥ȥ饯Ǥ
    */
    private Parser() {
    }

    /**
       ХȥХåե64ӥåͤϤ֤ͤޤХ
       Хåեΰ֤8Хȿʤߤޤ

       gcovλͤˤ64ӥåͤϡ32ӥåȡ32ӥåȤν
       ¤Ǥޤ

       @param bb ХȥХåե
       @return 64ӥå
       @throws IOException ϥ顼
    */
    public static long getInt64(final ByteBuffer bb) throws IOException {
	long low = bb.getInt();
	long high = bb.getInt();
	if (low < 0) {
	    low += (1L << Integer.SIZE);
	}
	high <<= Integer.SIZE;
	return high | low;
    }

    /**
       ХȥХåեʸϤΥ󥹥󥹤֤ޤ
       ʸĹ0ΤȤnull֤ޤ̥륿ߥ͡ȤΤ
       0ӥѥǥ󥰤0ϥåפ졢ХȥХåեΰ֤ʸ
       μΰ֤˿ʤߤޤ

       string: int32:0 | int32:length char* char:0 padding
       padding: | char:0 | char:0 char:0 | char:0 char:0 char:0

       @param bb ХȥХåե
       @return ʸ
       @throws IOException ϥ顼
    */
    public static String getString(final ByteBuffer bb) throws IOException {
	int length = bb.getInt();
	if (length == 0) {
	    return null;
	}
	byte[] bytes = new byte[length * SIZE_INT32];
	bb.get(bytes);

	int k;
	for (k = 0; k < bytes.length && bytes[k] != 0; ++k) {
	    continue;
	}
	return new String(bytes, 0, k, CHARSET);
    }

    /**
       ХȥХåեʸϤΥ󥹥󥹤֤ޤ

       󥹥󥹤Stirng.intern()֤ʸǤʳˤ
       ƤParser.getString()Ʊͤˤʤޤ

       @param bb ХȥХåե
       @return ʸ
       @throws IOException ϥ顼
    */
    public static String getInternString(final ByteBuffer bb)
	throws IOException {
	String s = getString(bb);
	return (s == null) ? null : s.intern();
    }
}
