package com.maroontress.gcovparser.gcno;

import com.maroontress.gcovparser.Parser;
import java.io.IOException;
import java.nio.ByteBuffer;

/**
   LINE쥳ɤǤ

   line: int32:line_no | int32:0 string:filename
*/
public final class LineRecord {

    /** ֹǤ */
    private int number;

    /** ե̾Ǥ */
    private String fileName;

    /**
       ХȥХåեLINE쥳ɤϤLINE쥳ɤ
       ХȥХåեΰ֤LINE쥳ɤƬΰ֤ǤʤФ
       ޤϡХȥХåեΰ֤LINE쥳ɤ
       ΰ֤˰ưޤ

       @param bb ХȥХåե
       @throws IOException ϥ顼
    */
    public LineRecord(final ByteBuffer bb) throws IOException {
	number = bb.getInt();
	fileName = (number != 0) ? null : Parser.getInternString(bb);
    }

    /**
       ֹޤ

       @return ֹ
    */
    public int getNumber() {
	return number;
    }

    /**
       ե̾ޤ

       @return ե̾
    */
    public String getFileName() {
	return fileName;
    }

    /**
       LINE쥳ɤνüɤޤ

       @return LINES쥳ɤνüʤtrueǤʤfalse
    */
    public boolean isTerminator() {
	return number == 0 && fileName == null;
    }
}
